# ---------------------------------------------------------------------------
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements.  See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License.  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ---------------------------------------------------------------------------

apiVersion: camel.apache.org/v1alpha1
kind: Kamelet
metadata:
  name: scp-sink
  annotations:
    camel.apache.org/kamelet.support.level: "Stable"
    camel.apache.org/catalog.version: "3.21.0"
    camel.apache.org/kamelet.icon: "data:image/svg+xml;base64,[encoded data, 7188 characters]"
    camel.apache.org/provider: "Apache Software Foundation"
    camel.apache.org/kamelet.group: "SCP"
    camel.apache.org/kamelet.namespace: "File"
  labels:
    camel.apache.org/kamelet.type: sink
spec:
  definition:
    title: SCP Sink
    description: |-
      Send file to an FTP Server through Secure Copy Protocol
    required:
      - serverName
      - serverPort
    type: object
    properties:
      serverName:
        title: Hostname
        description: The hostname of the FTP server
        type: string
      serverPort:
        title: Port
        description: The port of the FTP server
        type: string
      username:
        title: Username
        description: Username for accessing FTP Server
        type: string
      password:
        title: Password
        description: Password for accessing FTP Server
        type: string
        format: password
        x-descriptors:
        - urn:alm:descriptor:com.tectonic.ui:password
        - urn:camel:group:credentials
      privateKeyFile:
        title: Private Key File
        description: Set the private key file so that the SFTP endpoint can do private key verification.
        type: string
      privateKeyPassphrase:
        title: Private Key Passphrase
        description: Set the private key file passphrase so that the SFTP endpoint can do private key verification.
        type: string
      strictHostKeyChecking:
        title: Strict Host Checking
        description: Sets whether to use strict host key checking.
        type: string
        default: no
      useUserKnownHostsFile:
        title: Use User Known Hosts File
        description: If knownHostFile has not been explicit configured then use the host file from System.getProperty(user.home)/.ssh/known_hosts.
        type: boolean
        default: true
        x-descriptors:
        - 'urn:alm:descriptor:com.tectonic.ui:checkbox'
  dependencies:
    - "camel:core"
    - "camel:jsch"
    - "camel:kamelet"
  template:
    from:
      uri: kamelet:source
      steps:
      - to:
          uri: "scp:{{serverName}}:{{serverPort}}"
          parameters:
            username: "{{?username}}"
            password: "{{?password}}"
            privateKeyFile: "{{?privateKeyFile}}"
            privateKeyPassphrase: "{{?privateKeyPassphrase}}"
            strictHostKeyChecking: "{{?strictHostKeyChecking}}"
            useUserKnownHostsFile: "{{?useUserKnownHostsFile}}"